var dgram=require("dgram"),os=require("os"),EventEmitter=require("x.events.js").EventEmitter,Logger=require("x.logger.js"),xnm=xnm||{};xnm.aio=xnm.aio||{};xnm.aio.knx=xnm.aio.knx||{};
xnm.aio.knx.KNXGateway=function(a,c,b){this._logger=xnm.aio.knx.KNXGateway._logger;this.ip=a;this.localIp=c;this.uuid=b;this._stateMachine={state:xnm.aio.knx.KNXGateway._FSM.IDLE};this._eventEmitter=new EventEmitter;this._pendingStateReq=[];this._dataLink=null;this._isTempDatalink=!1;this._dataLinkRetryCount=0;this._dataLinkTimer=null;this._jobQueue=[]};xnm.aio.knx.KNXGateway._logger=Logger.getLogger("xnm.aio.knx");xnm.aio.knx.KNXGateway.STATE_RSP_TIMEOUT=500;
xnm.aio.knx.KNXGateway.BUFFERED_STATES_EXPIRED=6E4;xnm.aio.knx.KNXGateway._FSM={IDLE:1,MONITORING:2,START_MONITOR:3,STOP_MONITOR:4};xnm.aio.knx.KNXGateway._ipv4ToLong=function(a){a=a.split(".");return(parseInt(a[0])<<24)+(parseInt(a[1])<<16)+(parseInt(a[2])<<8)+parseInt(a[3])&4294967295};xnm.aio.knx.KNXGateway._longToIpv4=function(a){return(a>>24&255)+"."+(a>>16&255)+"."+(a>>8&255)+"."+(a&255)};
xnm.aio.knx.KNXGateway._adr2long=function(a){a=a.split("/");var c=0;switch(a.length){case 3:c+=parseInt(a[0])<<11;c+=parseInt(a[1])<<8;c+=parseInt(a[2]);break;case 2:c+=parseInt(a[0])<<8;c+=parseInt(a[1]);break;case 1:c+=parseInt(a[0])}return c};
xnm.aio.knx.KNXGateway.prototype={on:function(a,c){this._eventEmitter.on(a,c)},removeAllListeners:function(){this._eventEmitter.removeAllListeners()},removeListener:function(a,c){this._eventEmitter.removeListener(a,c)},startMonitor:function(a){if(a)this.on("open",a);this._fsmStartMonitor()},stopMonitor:function(a){if(a&&!this._isTempDatalink)this.on("close",a);this._fsmStopMonitor()},execute:function(a,c,b){a&&c?(a=new xnm.aio.knx.KNXGateway._Job(a,c,this,b),this._fsmExecuteJob(a)):b&&b(Error("invalid execute arguments"))},
evalGroupCommand:function(a,c,b){(a=xnm.aio.knx.KNXGateway._Device.resolve(a))?a.evalGroupCommand?a.evalGroupCommand(c,this,function(a,c){b&&b(a,c)}.bind(this)):b&&b(Error("device do not suport group command")):b&&b(Error("invalid device"))},_fsmStartMonitor:function(){switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._FSM.IDLE:this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.START_MONITOR;this._isTempDatalink=!1;this._startDataLink();break;case xnm.aio.knx.KNXGateway._FSM.START_MONITOR:this._isTempDatalink=
!1;break;case xnm.aio.knx.KNXGateway._FSM.MONITORING:this._isTempDatalink=!1;this._eventEmitter.emit("open");break;case xnm.aio.knx.KNXGateway._FSM.STOP_MONITOR:this._logger.log("warn","can not start the monitor again while stopping it")}},_fsmStopMonitor:function(){switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._FSM.IDLE:this._onClose();break;case xnm.aio.knx.KNXGateway._FSM.START_MONITOR:case xnm.aio.knx.KNXGateway._FSM.MONITORING:this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.STOP_MONITOR,
this._stopDataLink()}},_fsmDatalinkOpen:function(){switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._FSM.START_MONITOR:this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.MONITORING,this._isTempDatalink||this._onOpen(),this._dataLinkRetryCount=0,this._doJob()}},_fsmDatalinkClosed:function(a){a?this._logger.log("trace","data link stopped due to error"):this._logger.log("trace","data link stopped");switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._FSM.START_MONITOR:this._dataLink.removeAllListeners();
this._dataLink=null;this._isTempDatalink?(this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.IDLE,this._clearPendingStateReq(),this._cancelPendingJobs(),this._clearTempDataLinkTimer()):5>++this._dataLinkRetryCount?(this._logger.log("trace","auto restart monitor tunnel"),this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.START_MONITOR,this._startDataLink()):(this._onError(Error("can not connect monitor tunnel to knx gateway")),this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.IDLE,this._clearPendingStateReq(),
this._cancelPendingJobs(),this._onClose(!0));break;case xnm.aio.knx.KNXGateway._FSM.MONITORING:this._dataLink.removeAllListeners();this._dataLink=null;this._isTempDatalink?(this._clearTempDataLinkTimer(),0<this._jobQueue.length?(this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.START_MONITOR,this._startDataLink()):this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.IDLE):5>++this._dataLinkRetryCount?(this._logger.log("trace","auto restart monitor tunnel"),this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.START_MONITOR,
this._startDataLink()):(this._onError(Error("can not connect monitor tunnel to knx gateway")),this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.IDLE,this._clearPendingStateReq(),this._cancelPendingJobs(),this._onClose(!0));break;case xnm.aio.knx.KNXGateway._FSM.STOP_MONITOR:this._clearTempDataLinkTimer(),this._dataLink.removeAllListeners(),this._dataLink=null,this._isTempDatalink?0<this._jobQueue.length?(this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.START_MONITOR,this._startDataLink()):
this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.IDLE:(this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.IDLE,this._clearPendingStateReq(),this._cancelPendingJobs(),this._onClose(!1))}},_fsmDataLinkMessage:function(a,c){switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._FSM.MONITORING:var b=c.getData();switch(c.getAPCI()){case 1:for(var d=-1,f=0;f<this._pendingStateReq.length;f++){var e=this._pendingStateReq[f];if(e.address===a){clearTimeout(e.timer);e.callback(null,b);d=f;break}}0<=
d&&this._pendingStateReq.splice(d,1)}this._eventEmitter.emit("message",this.uuid,a,c)}},_fsmExecuteJob:function(a){switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._FSM.IDLE:this._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.START_MONITOR;this._isTempDatalink=!0;this._startDataLink();this._jobQueue.push(a);break;case xnm.aio.knx.KNXGateway._FSM.START_MONITOR:this._jobQueue.push(a);break;case xnm.aio.knx.KNXGateway._FSM.MONITORING:var c=this._jobQueue.length;this._jobQueue.push(a);0===
c&&this._doJob();break;case xnm.aio.knx.KNXGateway._FSM.STOP_MONITOR:this._jobQueue.push(a)}},_onOpen:function(){this._eventEmitter.emit("open")},_onError:function(a){this._eventEmitter.emit("error",a)},_onClose:function(a){this._eventEmitter.emit("close",a)},_sendCommand:function(a,c,b){this._sendCommandWithDL(this._dataLink,a,c,b)},_getState:function(a,c){this._getStateWithDL(this._dataLink,a,c)},_sendCommandWithDL:function(a,c,b,d){c=xnm.aio.knx.KNXGateway._adr2long(c);b=new xnm.aio.knx.KNXGateway.APDU(null,
2,b);a.send(c,b,function(a){d&&"function"===typeof d&&d(a)})},_getStateWithDL:function(a,c,b){c=xnm.aio.knx.KNXGateway._adr2long(c);var d=new xnm.aio.knx.KNXGateway.APDU(null,0,new Buffer([0]));a.send(c,d);var f=this;if(b){var e=this._pendingStateReq.length;a=setTimeout(function(){f._pendingStateReq.splice(e,1);b(Error("get state timeout"))},xnm.aio.knx.KNXGateway.STATE_RSP_TIMEOUT);this._pendingStateReq.push({address:c,timer:a,callback:b})}},_startDataLink:function(){var a=this;this._dataLink=new xnm.aio.knx.KNXGateway._DataLink(this.ip,
this.localIp);this._dataLink.on("connect",function(){a._fsmDatalinkOpen()});this._dataLink.on("close",function(c){a._fsmDatalinkClosed(c)});this._dataLink.on("error",function(c){a._logger.log("warn","monitor tunnel error:"+c.stack)});this._dataLink.on("message",function(c,b){a._fsmDataLinkMessage(c,b)});this._dataLink.connect()},_stopDataLink:function(){this._dataLink&&this._dataLink.close()},_doJob:function(){this._clearTempDataLinkTimer();0<this._jobQueue.length&&this._stateMachine.state===xnm.aio.knx.KNXGateway._FSM.MONITORING?
this._jobQueue[0].execute():0===this._jobQueue.length&&this._startTempDataLinkTimer()},_cancelPendingJobs:function(){for(var a=0;a<this._jobQueue.length;a++)this._jobQueue[a].cancel();this._jobQueue=[]},_clearPendingStateReq:function(){for(var a=0;a<this._pendingStateReq.length;a++){var c=this._pendingStateReq[a];c.timer&&clearTimeout(c.timer)}this._pendingStateReq=[]},_onJobDone:function(a){for(var c=-1,b=0;b<this._jobQueue.length;b++)a===this._jobQueue[b]&&(c=b);0<=c&&this._jobQueue.splice(c,1);
this._doJob()},_clearTempDataLinkTimer:function(){this._dataLinkTimer&&(clearTimeout(this._dataLinkTimer),this._dataLinkTimer=null)},_startTempDataLinkTimer:function(){var a=this;this._dataLinkTimer=setTimeout(function(){a._isTempDatalink&&(a._stateMachine.state=xnm.aio.knx.KNXGateway._FSM.STOP_MONITOR,a._stopDataLink())},3E4)}};xnm.aio.knx.KNXGateway._Job=function(a,c,b,d){this._device=a;this._jobDesc=c;this._knx=b;this._callback=d};
xnm.aio.knx.KNXGateway._Job.prototype={execute:function(){switch(this._jobDesc.type){case "command":this._doCommand();break;case "state":this._doState();break;default:this._done(Error("invalid job type"))}},cancel:function(){this._callback(Error("job canceled"))},_done:function(a,c){this._knx._onJobDone(this);this._callback(a,c)},_doCommand:function(){var a=xnm.aio.knx.KNXGateway._Device.resolve(this._device);a?a.doCommand(this._jobDesc,this._knx,function(a,b){a?this._done(a):this._done(null,b)}.bind(this)):
this._done(Error("invalid device"))},_doState:function(){var a=xnm.aio.knx.KNXGateway._Device.resolve(this._device);a?a.getState(this._jobDesc,this._knx,function(a,b){a?this._done(a):this._done(null,b)}.bind(this)):this._done(Error("invalid device"))}};xnm.aio.knx.KNXGateway._DPT=function(a){this.type=a};
xnm.aio.knx.KNXGateway._DPT.resolve=function(a){if(3>=a.length)return null;var c=a.indexOf("-");if(0>=c)return null;var b=a.substring(0,c);if("DPT"==b){if(5>a.length)return null;b=a}else if("DPST"==b){c=a.indexOf("-",c+1);if(0>c)return null;b=a.substring(0,c)}else return null;switch(b){case "DPT-1":case "DPST-1":return new xnm.aio.knx.KNXGateway._DPT.DPT1(a);case "DPT-3":case "DPST-3":return new xnm.aio.knx.KNXGateway._DPT.DPT3(a);case "DPT-5":case "DPST-5":return new xnm.aio.knx.KNXGateway._DPT.DPT5(a);
case "DPT-9":case "DPST-9":return new xnm.aio.knx.KNXGateway._DPT.DPT9(a);case "DPT-20":case "DPST-20":return new xnm.aio.knx.KNXGateway._DPT.DPT20(a)}return null};xnm.aio.knx.KNXGateway._DPT.prototype.getValue=function(a,c,b){b&&b(Error("not implemented"))};xnm.aio.knx.KNXGateway._DPT.prototype._resolveData=function(a){return a.toString("hex")};xnm.aio.knx.KNXGateway._DPT.DPT1=function(a){xnm.aio.knx.KNXGateway._DPT.call(this,a)};xnm.aio.knx.KNXGateway._DPT.DPT1.prototype=new xnm.aio.knx.KNXGateway._DPT;
xnm.aio.knx.KNXGateway._DPT.DPT1.prototype.constructor=xnm.aio.knx.KNXGateway._DPT.DPT1;xnm.aio.knx.KNXGateway._DPT.DPT1.prototype.evalValue=function(a,c,b,d){0!=a&&1!=a?d&&d(Error("invalid value")):d&&d(null,this._resolveValue(a))};xnm.aio.knx.KNXGateway._DPT.DPT1.prototype.setValue=function(a,c,b,d){if(0!=a&&1!=a)d&&d(Error("invalid value"));else{var f=new Buffer([a]);c._sendCommand(b,f,function(b){d&&d(b,b?null:this._resolveValue(a))}.bind(this))}};
xnm.aio.knx.KNXGateway._DPT.DPT1.prototype.invValue=function(a,c,b,d){var f=null;a._getState(b,function(b,g){b?d&&d(b):(f=0==g.readUInt8(0)?new Buffer([1]):new Buffer([0]),a._sendCommand(c,f,function(a){d&&d(a,a?null:this._resolveData(f))}.bind(this)))}.bind(this))};xnm.aio.knx.KNXGateway._DPT.DPT1.prototype.getValue=function(a,c,b){a._getState(c,function(a,c){a?b&&b(a):b&&b(null,this._resolveData(c))}.bind(this))};
xnm.aio.knx.KNXGateway._DPT.DPT1.prototype._resolveData=function(a){a=a.readUInt8(0);return this._resolveValue(a)};
xnm.aio.knx.KNXGateway._DPT.DPT1.prototype._resolveValue=function(a){switch(this.type){case "DPT-1":case "DPST-1-1":return a?"on":"off";case "DPST-1-2":return a?"true":"false";case "DPST-1-3":return a?"enable":"disable";case "DPST-1-4":return a?"ramp":"no ramp";case "DPST-1-5":return a?"alarm":"no alarm";case "DPST-1-6":return a?"high":"low";case "DPST-1-7":return a?"increase":"decrease";case "DPST-1-8":return a?"down":"up";case "DPST-1-9":return a?"closed":"open";case "DPST-1-10":return a?"start":
"stop";case "DPST-1-11":return a?"active":"inactive";case "DPST-1-12":return a?"inverted":"not inverted";case "DPST-1-13":return a?"cyclically":"start/stop";case "DPST-1-14":return a?"calculated":"fixed";case "DPST-1-15":return a?"reset command":"no action";case "DPST-1-16":return a?"acknowledge command":"no action";case "DPST-1-18":return a?"occupied":"not occupied";case "DPST-1-19":return a?"open":"closed";case "DPST-1-21":return a?"logical function AND":"logical function OR";case "DPST-1-22":return a?
"scene B":"scene A";case "DPST-1-23":return a?"move Up/Down +StepStop mode (blind)":"only move Up/Down mode (shutter)";default:return null}};xnm.aio.knx.KNXGateway._DPT.DPT3=function(a){xnm.aio.knx.KNXGateway._DPT.call(this,a)};xnm.aio.knx.KNXGateway._DPT.DPT3.prototype=new xnm.aio.knx.KNXGateway._DPT;xnm.aio.knx.KNXGateway._DPT.DPT3.prototype.constructor=xnm.aio.knx.KNXGateway._DPT.DPT3;
xnm.aio.knx.KNXGateway._DPT.DPT3.prototype.stepUp=function(a,c,b,d){a=this._getStepcode(a);null==a?d&&d(Error("invalid interval")):this._step(1,a,c,b,function(a){d&&d(a)})};xnm.aio.knx.KNXGateway._DPT.DPT3.prototype.stepDown=function(a,c,b,d){a=this._getStepcode(a);null==a?d&&d(Error("invalid interval")):this._step(0,a,c,b,function(a){d&&d(a)})};xnm.aio.knx.KNXGateway._DPT.DPT3.prototype._step=function(a,c,b,d,f){a=new Buffer([a<<3|c]);b._sendCommand(d,a,function(a){f&&f(a)})};
xnm.aio.knx.KNXGateway._DPT.DPT3.prototype._getStepcode=function(a){var c=null;switch(a){case 1:c=7;break;case 3:c=6;break;case 6:c=5;break;case 12:c=4;break;case 25:c=3;break;case 50:c=2;break;case 100:c=1}return c};xnm.aio.knx.KNXGateway._DPT.DPT5=function(a){xnm.aio.knx.KNXGateway._DPT.call(this,a)};xnm.aio.knx.KNXGateway._DPT.DPT5.prototype=new xnm.aio.knx.KNXGateway._DPT;xnm.aio.knx.KNXGateway._DPT.DPT5.prototype.constructor=xnm.aio.knx.KNXGateway._DPT.DPT5;
xnm.aio.knx.KNXGateway._DPT.DPT5.prototype.evalValue=function(a,c,b,d){(a=this._getBuffer(a))?d&&d(null,this._resolveData(a)):d&&d(Error("invalid value"))};xnm.aio.knx.KNXGateway._DPT.DPT5.prototype.setValue=function(a,c,b,d){var f=this._getBuffer(a);f?c._sendCommand(b,f,function(a){d&&d(a,a?null:this._resolveData(f))}.bind(this)):d&&d(Error("invalid value"))};
xnm.aio.knx.KNXGateway._DPT.DPT5.prototype.incValue=function(a,c,b,d,f){var e=null;c._getState(d,function(d,h){if(d)f&&f(d);else{e=this._resolveData(h);e+=a;var k=this._getBuffer(e);c._sendCommand(b,k,function(a){f&&f(a,a?null:this._resolveData(k))}.bind(this))}}.bind(this))};
xnm.aio.knx.KNXGateway._DPT.DPT5.prototype.cincValue=function(a,c,b,d,f){var e=null;c._getState(d,function(d,h){if(d)f&&f(d);else if(e=this._resolveData(h),0==e)f&&f(null,0);else{e+=a;var k=this._getBuffer(e);c._sendCommand(b,k,function(a){f&&f(a,a?null:this._resolveData(k))}.bind(this))}}.bind(this))};
xnm.aio.knx.KNXGateway._DPT.DPT5.prototype.decValue=function(a,c,b,d,f){var e=null;c._getState(d,function(d,h){if(d)f&&f(d);else{e=this._resolveData(h);e-=a;var k=this._getBuffer(e);c._sendCommand(b,k,function(a){f&&f(a,a?null:this._resolveData(k))}.bind(this))}}.bind(this))};
xnm.aio.knx.KNXGateway._DPT.DPT5.prototype.cdecValue=function(a,c,b,d,f){var e=null;c._getState(d,function(d,h){if(d)f&&f(d);else if(e=this._resolveData(h),0==e)f&&f(null,0);else{e-=a;var k=this._getBuffer(e);c._sendCommand(b,k,function(a){f&&f(a,a?null:this._resolveData(k))}.bind(this))}}.bind(this))};xnm.aio.knx.KNXGateway._DPT.DPT5.prototype.getValue=function(a,c,b){a._getState(c,function(a,c){a?b&&b(a):b&&b(null,this._resolveData(c))}.bind(this))};
xnm.aio.knx.KNXGateway._DPT.DPT5.prototype._resolveData=function(a){a=a.readUInt8(1);return this._resolveValue(a)};xnm.aio.knx.KNXGateway._DPT.DPT5.prototype._resolveValue=function(a){switch(this.type){case "DPT-5":case "DPST-5-1":return Math.round(a/255*100);case "DPST-5-3":return Math.round(a/255*360);case "DPST-5-4":return a;default:return Math.round(a/255*100)}};
xnm.aio.knx.KNXGateway._DPT.DPT5.prototype._getBuffer=function(a){var c=new Buffer(2);c.writeUInt8(0,0);switch(this.type){case "DPT-5":case "DPST-5-1":0>a&&(a=0);100<a&&(a=100);a=Math.round(a/100*255);break;case "DPST-5-3":0>a&&(a=0);360<a&&(a=360);a=Math.round(a/360*255);break;case "DPST-5-4":0>a&&(a=0);255<a&&(a=255);break;default:a=Math.round(a/100*255)}c.writeUInt8(a,1);return c};xnm.aio.knx.KNXGateway._DPT.DPT9=function(a){xnm.aio.knx.KNXGateway._DPT.call(this,a)};
xnm.aio.knx.KNXGateway._DPT.DPT9.prototype=new xnm.aio.knx.KNXGateway._DPT;xnm.aio.knx.KNXGateway._DPT.DPT9.prototype.constructor=xnm.aio.knx.KNXGateway._DPT.DPT9;xnm.aio.knx.KNXGateway._DPT.DPT9.prototype.evalValue=function(a,c,b,d){(a=this._getBuffer(a))?d&&d(null,this._resolveData(a)):d&&d(Error("invalid value"))};xnm.aio.knx.KNXGateway._DPT.DPT9.prototype.setValue=function(a,c,b,d){var f=this._getBuffer(a);f?c._sendCommand(b,f,function(a){d&&d(a,a?null:this._resolveData(f))}.bind(this)):d&&d(Error("invalid value"))};
xnm.aio.knx.KNXGateway._DPT.DPT9.prototype.incValue=function(a,c,b,d,f){var e=null;c._getState(d,function(d,h){if(d)f&&f(d);else{e=this._resolveData(h);e+=a;var k=this._getBuffer(e);c._sendCommand(b,k,function(a){f&&f(a,a?null:this._resolveData(k))}.bind(this))}}.bind(this))};
xnm.aio.knx.KNXGateway._DPT.DPT9.prototype.decValue=function(a,c,b,d,f){var e=null;c._getState(d,function(d,h){if(d)f&&f(d);else{e=this._resolveData(h);e-=a;var k=this._getBuffer(e);c._sendCommand(b,k,function(a){f&&f(a,a?null:this._resolveData(k))}.bind(this))}}.bind(this))};xnm.aio.knx.KNXGateway._DPT.DPT9.prototype.getValue=function(a,c,b){a._getState(c,function(a,c){a?b&&b(a):b&&b(null,this._resolveData(c))}.bind(this))};
xnm.aio.knx.KNXGateway._DPT.DPT9.prototype._resolveData=function(a){a=a.readUInt16BE(1);return this._resolveValue(a)};xnm.aio.knx.KNXGateway._DPT.DPT9.prototype._resolveValue=function(a){switch(this.type){case "DPT-9":case "DPST-9-1":return this._short2float(a);default:return this._short2float(a)}};
xnm.aio.knx.KNXGateway._DPT.DPT9.prototype._getBuffer=function(a){var c=new Buffer(3);c.writeUInt8(0,0);switch(this.type){case "DPT-9":case "DPST-9-1":-273>a&&(a=-273);670760<a&&(a=670760);a=this._float2short(a);break;default:a=this._float2short(a)}c.writeUInt16BE(a,1);return c};xnm.aio.knx.KNXGateway._DPT.DPT9.prototype._float2short=function(a){var c=Math.floor(Math.log(a)/Math.LN2);return Math.round(a/Math.pow(2,c)*100)|c<<11|(0<=a?0:1)<<15};
xnm.aio.knx.KNXGateway._DPT.DPT9.prototype._short2float=function(a){var c=.01*(a&2047)*Math.pow(2,a>>11&15);1==(a>>15&1)&&(c=0-c);return c};xnm.aio.knx.KNXGateway._DPT.DPT20=function(a){xnm.aio.knx.KNXGateway._DPT.call(this,a)};xnm.aio.knx.KNXGateway._DPT.DPT20.prototype=new xnm.aio.knx.KNXGateway._DPT;xnm.aio.knx.KNXGateway._DPT.DPT20.prototype.constructor=xnm.aio.knx.KNXGateway._DPT.DPT20;
xnm.aio.knx.KNXGateway._DPT.DPT20.prototype.evalValue=function(a,c,b,d){0>a&&255<a?d&&d(Error("invalid value")):d&&d(null,this._resolveValue(a))};xnm.aio.knx.KNXGateway._DPT.DPT20.prototype.setValue=function(a,c,b,d){if(0>a&&255<a)d&&d(Error("invalid value"));else{var f=new Buffer([0,a]);c._sendCommand(b,f,function(b){d&&d(b,b?null:this._resolveValue(a))}.bind(this))}};xnm.aio.knx.KNXGateway._DPT.DPT20.prototype.getValue=function(a,c,b){a._getState(c,function(a,c){a?b&&b(a):b&&b(null,this._resolveData(c))}.bind(this))};
xnm.aio.knx.KNXGateway._DPT.DPT20.prototype._resolveData=function(a){a=a.readUInt8(1);return this._resolveValue(a)};xnm.aio.knx.KNXGateway._DPT.DPT20.prototype._resolveValue=function(a){switch(this.type){case "DPT-20":case "DPST-20-1":switch(a){case 0:return"autonomous";case 1:return"slave";case 2:return"master";default:return"unknow"}case "DPST-20-102":return a&1?"comfort":a&2?"standby":a&4?"economy":a&8?"protection":"auto";default:return null}};
xnm.aio.knx.KNXGateway._Device=function(a){this._device=a};
xnm.aio.knx.KNXGateway._Device.resolve=function(a){if(!a)return null;var c=null;switch(a.type){case "outlet":c=new xnm.aio.knx.KNXGateway._Device.Outlet(a);break;case "lighting":c=new xnm.aio.knx.KNXGateway._Device.Lighting(a);break;case "blind":c=new xnm.aio.knx.KNXGateway._Device.Blind(a);break;case "shutter":c=new xnm.aio.knx.KNXGateway._Device.Shutter(a);break;case "heater":c=new xnm.aio.knx.KNXGateway._Device.Heater(a);break;case "1bit":c=new xnm.aio.knx.KNXGateway._Device.BIT_1(a);break;case "1byte":c=
new xnm.aio.knx.KNXGateway._Device.Byte_1(a)}return c};
xnm.aio.knx.KNXGateway._Device.prototype={getDefaultChannel:function(){return null},_getWriteableGa:function(a){if(!a.actuator)return Error("invalid actuator");if(!a.actuator.flags)return Error("invalid actuator flag");if(-1===a.actuator.flags.indexOf("W"))return Error("actuator has no wtire flag");if(!a.actuator.ga||0===a.actuator.ga.length)return Error("actuator has no group address");for(var c,b,d=0;d<a.actuator.ga.length;d++){var f=a.actuator.ga[d];if("Receive"===f.type&&f.address){b=f.address;
break}else"Send"===f.type&&f.address&&(c=f.address)}return b||c},_getReadableGa:function(a){if(!a.status)return Error("invalid status");if(!a.status.flags)return Error("invalid status flag");if(-1===a.status.flags.indexOf("R"))return Error("status has no read flag");if(!a.status.ga||0===a.status.ga.length)return Error("status has no group address");for(var c,b=0;b<a.status.ga.length;b++){var d=a.status.ga[b];if("Send"===d.type&&d.address){c=d.address;break}}return c},_getState:function(a,c,b){if(this._device[a]){var d=
this._getReadableGa(this._device[a]);d?d instanceof Error?b&&b(d):xnm.aio.knx.KNXGateway._DPT.resolve(this._device[a].status.type).getValue(c,d,function(c,d){if(c)b&&b(c);else{var g={channel:a,state:d};b&&b(null,g)}}.bind(this)):b&&b(Error("invalid device has no readable address"))}else b&&b(Error("invalid channel name"))},_resolveEvent:function(a,c){return c.status&&c.status.type?xnm.aio.knx.KNXGateway._DPT.resolve(c.status.type)._resolveData(a):a.toString("hex")}};
xnm.aio.knx.KNXGateway._Device.Outlet=function(a){xnm.aio.knx.KNXGateway._Device.call(this,a)};xnm.aio.knx.KNXGateway._Device.Outlet.prototype=new xnm.aio.knx.KNXGateway._Device;xnm.aio.knx.KNXGateway._Device.Outlet.prototype.constructor=xnm.aio.knx.KNXGateway._Device.Outlet;
xnm.aio.knx.KNXGateway._Device.Outlet.prototype.doCommand=function(a,c,b){var d={},f=a.command,e=a.channel;e||(e=this.getDefaultChannel());if(this._device[e])if(a=this._getWriteableGa(this._device[e]))if(a instanceof Error)b&&b(a);else{var g=null;switch(f){case "on":g=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);g.setValue(1,c,a,function(a,c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;case "off":g=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);
g.setValue(0,c,a,function(a,c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;case "toggle":f=this._getReadableGa(this._device[e]);if(!f){b&&b(Error("invalid device has no readable address"));break}if(f instanceof Error){b&&b(f);break}g=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);g.invValue(c,a,f,function(a,c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;default:b&&b(Error("invalid device command"))}}else b&&b(Error("invalid device has no writeable address"));
else b&&b(Error("invalid device"))};
xnm.aio.knx.KNXGateway._Device.Outlet.prototype.evalGroupCommand=function(a,c,b){var d={},f=a.command,e=a.channel;e||(e=this.getDefaultChannel());if(this._device[e])if(a=this._getWriteableGa(this._device[e]))if(a instanceof Error)b&&b(a);else{var g=null;switch(f){case "on":g=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);g.evalValue(1,c,a,function(a,c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;case "off":g=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);g.evalValue(0,
c,a,function(a,c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;default:b&&b(Error("invalid device group command"))}}else b&&b(Error("invalid device has no writeable address"));else b&&b(Error("invalid device"))};xnm.aio.knx.KNXGateway._Device.Outlet.prototype.getState=function(a,c,b){var d;a&&a.channel&&(d=a.channel);d||(d=this.getDefaultChannel());this._getState(d,c,b)};xnm.aio.knx.KNXGateway._Device.Outlet.prototype.getDefaultChannel=function(){return"switch"};
xnm.aio.knx.KNXGateway._Device.Lighting=function(a){xnm.aio.knx.KNXGateway._Device.call(this,a)};xnm.aio.knx.KNXGateway._Device.Lighting.prototype=new xnm.aio.knx.KNXGateway._Device;xnm.aio.knx.KNXGateway._Device.Lighting.prototype.constructor=xnm.aio.knx.KNXGateway._Device.Lighting;
xnm.aio.knx.KNXGateway._Device.Lighting.prototype.doCommand=function(a,c,b){var d={},f,e=a.command,g=a.channel;if(!g)switch(e){case "on":case "off":case "toggle":g="switch";break;case "dimUp":case "dimDown":g="step";break;default:g="value"}if(this._device[g]){var h=this._getWriteableGa(this._device[g]);if(h)if(h instanceof Error)b&&b(h);else switch(e){case "on":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(1,c,h,function(a,c){!a&&c&&(d=[],d.push({channel:g,state:c}),
d.push({channel:"value",state:100}));b&&b(a,a?null:d)}.bind(this));break;case "off":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(0,c,h,function(a,c){a||(d=[],d.push({channel:g,state:c}),d.push({channel:"value",state:0}));b&&b(a,a?null:d)}.bind(this));break;case "toggle":f=this._getReadableGa(this._device[g]);if(!f){b&&b(Error("invalid device has no readable address"));break}if(f instanceof Error){b&&b(h);break}a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);
a.invValue(c,h,f,function(a,c){a||(d=[],d.push({channel:g,state:c}),d.push({channel:"value",state:"on"==c?100:0}));b&&b(a,a?null:d)}.bind(this));break;case "dimUp":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.stepUp(6,c,h,function(a){a||(d=[],d.push({channel:"switch",state:null}),d.push({channel:"value",state:null}));setTimeout(function(){b&&b(a,a?null:d)},500)});break;case "dimDown":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.stepDown(6,c,h,function(a){a||
(d=[],d.push({channel:"switch",state:null}),d.push({channel:"value",state:null}));setTimeout(function(){b&&b(a,a?null:d)},500)});break;default:if(3<=e.length&&("inc"==e.substr(0,3).toLowerCase()||"dec"==e.substr(0,3).toLowerCase())){var k=e.substr(0,3),e=e.substr(3);""==e&&(e="10");e.match(/^\d+$/)?(e=parseInt(e),(f=this._getReadableGa(this._device[g]))?f instanceof Error?b&&b(f):(a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a["inc"==k?"incValue":"decValue"](e,c,h,f,function(a,
c){a||null==c||(d=[],d.push({channel:"switch",state:0<c?"on":"off"}),d.push({channel:g,state:c}));b&&b(a,a?null:d)})):b&&b(Error("invalid device has no readable address"))):b&&b(Error("invalid device command"))}else 4<=e.length&&("cinc"==e.substr(0,4).toLowerCase()||"cdec"==e.substr(0,4).toLowerCase())?(k=e.substr(0,4),e=e.substr(4),""==e&&(e="10"),e.match(/^\d+$/)?(e=parseInt(e),(f=this._getReadableGa(this._device[g]))?f instanceof Error?b&&b(f):(a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),
a["cinc"==k?"cincValue":"cdecValue"](e,c,h,f,function(a,c){a||null==c||(d=[],d.push({channel:"switch",state:0<c?"on":"off"}),d.push({channel:g,state:c}));b&&b(a,a?null:d)})):b&&b(Error("invalid device has no readable address"))):b&&b(Error("invalid device command"))):(5<e.length&&"dimto"===e.substr(0,5).toLowerCase()&&(e=e.substr(5)),e.match(/^\d+$/)?(e=parseInt(e),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a.setValue(e,c,h,function(a,c){a||null==c||(d=[],d.push({channel:"switch",
state:0<c?"on":"off"}),d.push({channel:g,state:c}));b&&b(a,a?null:d)})):b&&b(Error("invalid device command")))}else b&&b(Error("invalid device has no writeable address"))}else b&&b(Error("invalid device"))};
xnm.aio.knx.KNXGateway._Device.Lighting.prototype.evalGroupCommand=function(a,c,b){var d={},f=a.command,e=a.channel;if(!e)switch(f){case "on":case "off":e="switch";break;case "toggle":b&&b(Error("invalid device group command"));return;case "dimUp":case "dimDown":e="step";break;default:e="value"}if(this._device[e]){var g=this._getWriteableGa(this._device[e]);if(g)if(g instanceof Error)b&&b(g);else switch(f){case "on":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);a.evalValue(1,
c,g,function(a,c){!a&&c&&(d=[],d.push({channel:e,state:c}),d.push({channel:"value",state:100}));b&&b(a,a?null:d)}.bind(this));break;case "off":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);a.setValue(0,c,g,function(a,c){a||(d=[],d.push({channel:e,state:c}),d.push({channel:"value",state:0}));b&&b(a,a?null:d)}.bind(this));break;case "dimUp":case "dimDown":d=[];d.push({channel:"switch",state:null});d.push({channel:"value",state:null});b&&b(null,d);break;default:3<=f.length&&("inc"==
f.substr(0,3).toLowerCase()||"dec"==f.substr(0,3).toLowerCase())?b&&b(Error("invalid device group command")):(5<f.length&&"dimto"===f.substr(0,5).toLowerCase()&&(f=f.substr(5)),f.match(/^\d+$/)?(f=parseInt(f),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type),a.evalValue(f,c,g,function(a,c){a||null==c||(d=[],d.push({channel:"switch",state:0<c?"on":"off"}),d.push({channel:e,state:c}));b&&b(a,a?null:d)})):b&&b(Error("invalid device group command")))}else b&&b(Error("invalid device has no writeable address"))}else b&&
b(Error("invalid device"))};xnm.aio.knx.KNXGateway._Device.Lighting.prototype.getState=function(a,c,b){var d;a&&a.channel&&(d=a.channel);d||(d=this.getDefaultChannel());this._getState(d,c,b)};xnm.aio.knx.KNXGateway._Device.Lighting.prototype.getDefaultChannel=function(){return"value"};xnm.aio.knx.KNXGateway._Device.Blind=function(a){xnm.aio.knx.KNXGateway._Device.call(this,a)};xnm.aio.knx.KNXGateway._Device.Blind.prototype=new xnm.aio.knx.KNXGateway._Device;
xnm.aio.knx.KNXGateway._Device.Blind.prototype.constructor=xnm.aio.knx.KNXGateway._Device.Blind;
xnm.aio.knx.KNXGateway._Device.Blind.prototype.doCommand=function(a,c,b){var d,f={},e=a.command,g=a.channel;if(!g)switch(e){case "stepUp":case "stepDown":g="blind_step";break;case "lamellaUp":case "lamellaDown":g="lamella_step";break;case "moveUp":case "moveDown":g="blind_move";break;case "stop":g="blind_stop";break;default:g="blind_position",1<e.length&&"l"===e.substr(0,1).toLowerCase()?g="lamella_position":7<e.length&&"movetol"===e.substr(0,7).toLowerCase()?g="lamella_position":4<=e.length&&"incl"===
e.substr(0,4).toLowerCase()?g="lamella_position":4<=e.length&&"decl"===e.substr(0,4).toLowerCase()&&(g="lamella_position")}if(this._device[g]){var h=this._getWriteableGa(this._device[g]);if(h)if(h instanceof Error)b&&b(h);else switch(e){case "stepUp":case "lamellaUp":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(0,c,h,function(a){a||(f.channel="stepUp"==e?"blind_position":"lamella_position",f.state=null);setTimeout(function(){b&&b(a,a?null:f)},500)}.bind(this));break;
case "stepDown":case "lamellaDown":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(1,c,h,function(a){a||(f.channel="stepDown"==e?"blind_position":"lamella_position",f.state=null);setTimeout(function(){b&&b(a,a?null:f)},500)}.bind(this));break;case "moveUp":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(0,c,h,function(a){a||(f.channel="blind_position",f.state=null);b&&b(a,a?null:f)}.bind(this));break;case "moveDown":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);
a.setValue(1,c,h,function(a){a||(f.channel="blind_position",f.state=null);b&&b(a,a?null:f)}.bind(this));break;case "stop":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(0,c,h,function(a){a||(f.channel="blind_position",f.state=null);b&&b(a,a?null:f)}.bind(this));break;default:if(3<=e.length&&("inc"===e.substr(0,3).toLowerCase()||"dec"===e.substr(0,3).toLowerCase())){var k=e.substr(0,3),e=e.substr(3);1<=e.length&&"l"===e.substr(0,1).toLowerCase()&&(e=e.substr(1));""==
e&&(e="10");e.match(/^\d+$/)?(e=parseInt(e),(d=this._getReadableGa(this._device[g]))?d instanceof Error?b&&b(d):(a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a["inc"==k?"incValue":"decValue"](e,c,h,d,function(a,c){a||null==c||(f.channel=g,f.state=c);b&&b(a,a?null:f)})):b&&b(Error("invalid device has no readable address"))):b&&b(Error("invalid device command"))}else 6<e.length&&"moveto"===e.substr(0,6).toLowerCase()&&(e=e.substr(6)),1<e.length&&"l"===e.substr(0,1).toLowerCase()&&
(e=e.substr(1)),e.match(/^\d+$/)?(e=parseInt(e),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a.setValue(e,c,h,function(a,c){a||null==c||(f.channel=g,f.state=c);b&&b(a,a?null:f)})):b&&b(Error("invalid device command"))}else b&&b(Error("invalid device has no writeable address"))}else b&&b(Error("invalid device"))};
xnm.aio.knx.KNXGateway._Device.Blind.prototype.evalGroupCommand=function(a,c,b){var d={},f=a.command,e=a.channel;if(!e)switch(f){case "stepUp":case "stepDown":e="blind_step";break;case "lamellaUp":case "lamellaDown":e="lamella_step";break;case "moveUp":case "moveDown":e="blind_move";break;case "stop":e="blind_stop";break;default:if(e="blind_position",1<f.length&&"l"===f.substr(0,1).toLowerCase())e="lamella_position";else if(7<f.length&&"movetol"===f.substr(0,7).toLowerCase())e="lamella_position";
else{if(4<=f.length&&"incl"===f.substr(0,4).toLowerCase()){b&&b(Error("invalid device group command"));return}if(4<=f.length&&"decl"===f.substr(0,4).toLowerCase()){b&&b(Error("invalid device group command"));return}}}if(this._device[e]){var g=this._getWriteableGa(this._device[e]);if(g)if(g instanceof Error)b&&b(g);else switch(f){case "lamellaUp":case "lamellaDown":d.channel="lamella_position";d.state=null;b&&b(null,d);break;case "stepUp":case "stepDown":case "moveUp":case "moveDown":case "stop":d.channel=
"blind_position";d.state=null;b&&b(null,d);break;default:3<=f.length&&("inc"===f.substr(0,3).toLowerCase()||"dec"===f.substr(0,3).toLowerCase())?b&&b(Error("invalid device group command")):(6<f.length&&"moveto"===f.substr(0,6).toLowerCase()&&(f=f.substr(6)),1<f.length&&"l"===f.substr(0,1).toLowerCase()&&(f=f.substr(1)),f.match(/^\d+$/)?(f=parseInt(f),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type),a.evalValue(f,c,g,function(a,c){a||null==c||(d.channel=e,d.state=c);b&&b(a,a?null:
d)})):b&&b(Error("invalid device group command")))}else b&&b(Error("invalid device has no writeable address"))}else b&&b(Error("invalid device"))};xnm.aio.knx.KNXGateway._Device.Blind.prototype.getState=function(a,c,b){var d;a&&a.channel&&(d=a.channel);d||(d=this.getDefaultChannel());this._getState(d,c,b)};xnm.aio.knx.KNXGateway._Device.Blind.prototype.getDefaultChannel=function(){return"blind_position"};xnm.aio.knx.KNXGateway._Device.Shutter=function(a){xnm.aio.knx.KNXGateway._Device.call(this,a)};
xnm.aio.knx.KNXGateway._Device.Shutter.prototype=new xnm.aio.knx.KNXGateway._Device;xnm.aio.knx.KNXGateway._Device.Shutter.prototype.constructor=xnm.aio.knx.KNXGateway._Device.Shutter;
xnm.aio.knx.KNXGateway._Device.Shutter.prototype.doCommand=function(a,c,b){var d,f={},e=a.command,g=a.channel;if(!g)switch(e){case "stepUp":case "stepDown":g="shutter_step";break;case "moveUp":case "moveDown":g="shutter_move";break;case "stop":g="shutter_stop";break;default:g="shutter_position"}if(this._device[g]){var h=this._getWriteableGa(this._device[g]);if(h)if(h instanceof Error)b&&b(h);else switch(e){case "stepUp":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(0,
c,h,function(a){a||(f.channel="shutter_position",f.state=null);setTimeout(function(){b&&b(a,a?null:f)},500)}.bind(this));break;case "stepDown":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(1,c,h,function(a){a||(f.channel="shutter_position",f.state=null);setTimeout(function(){b&&b(a,a?null:f)},500)}.bind(this));break;case "moveUp":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(0,c,h,function(a){a||(f.channel="shutter_position",f.state=
null);b&&b(a,a?null:f)}.bind(this));break;case "moveDown":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(1,c,h,function(a){a||(f.channel="shutter_position",f.state=null);b&&b(a,a?null:f)}.bind(this));break;case "stop":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(0,c,h,function(a){a||(f.channel="blind_position",f.state=null);b&&b(a,a?null:f)}.bind(this));break;default:if(3<=e.length&&("inc"===e.substr(0,3).toLowerCase()||"dec"===e.substr(0,
3).toLowerCase())){var k=e.substr(0,3),e=e.substr(3);""==e&&(e="10");e.match(/^\d+$/)?(e=parseInt(e),(d=this._getReadableGa(this._device[g]))?d instanceof Error?b&&b(d):(a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a["inc"==k?"incValue":"decValue"](e,c,h,d,function(a,c){a||null==c||(f.channel=g,f.state=c);b&&b(a,a?null:f)})):b&&b(Error("invalid device has no readable address"))):b&&b(Error("invalid device command"))}else 6<e.length&&"moveto"===e.substr(0,6).toLowerCase()&&
(e=e.substr(6)),e.match(/^\d+$/)?(e=parseInt(e),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a.setValue(e,c,h,function(a,c){a||null==c||(f.channel=g,f.state=c);b&&b(a,a?null:f)})):b&&b(Error("invalid device command"))}else b&&b(Error("invalid device has no writeable address"))}else b&&b(Error("invalid device"))};
xnm.aio.knx.KNXGateway._Device.Shutter.prototype.evalGroupCommand=function(a,c,b){var d={},f=a.command,e=a.channel;if(!e)switch(f){case "stepUp":case "stepDown":e="shutter_step";break;case "moveUp":case "moveDown":e="shutter_move";break;case "stop":e="shutter_stop";break;default:e="shutter_position"}if(this._device[e]){var g=this._getWriteableGa(this._device[e]);if(g)if(g instanceof Error)b&&b(g);else switch(f){case "stepUp":case "stepDown":case "moveUp":case "moveDown":case "stop":d.channel="shutter_position";
d.state=null;b&&b(null,d);break;default:3<=f.length&&("inc"===f.substr(0,3).toLowerCase()||"dec"===f.substr(0,3).toLowerCase())?b&&b(Error("invalid device group command")):(6<f.length&&"moveto"===f.substr(0,6).toLowerCase()&&(f=f.substr(6)),f.match(/^\d+$/)?(f=parseInt(f),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type),a.evalValue(f,c,g,function(a,c){a||null==c||(d.channel=e,d.state=c);b&&b(a,a?null:d)})):b&&b(Error("invalid device command")))}else b&&b(Error("invalid device has no writeable address"))}else b&&
b(Error("invalid device"))};xnm.aio.knx.KNXGateway._Device.Shutter.prototype.getState=function(a,c,b){var d;a&&a.channel&&(d=a.channel);d||(d="shutter_position");this._getState(d,c,b)};xnm.aio.knx.KNXGateway._Device.Shutter.prototype.getDefaultChannel=function(){return"shutter_position"};xnm.aio.knx.KNXGateway._Device.Heater=function(a){xnm.aio.knx.KNXGateway._Device.call(this,a)};xnm.aio.knx.KNXGateway._Device.Heater.prototype=new xnm.aio.knx.KNXGateway._Device;
xnm.aio.knx.KNXGateway._Device.Heater.prototype.constructor=xnm.aio.knx.KNXGateway._Device.Heater;
xnm.aio.knx.KNXGateway._Device.Heater.prototype.doCommand=function(a,c,b){var d,f={},e=a.command,g=a.channel;if(!g)switch(e){case "auto":case "comfort":case "standby":case "economy":case "protection":g="mode";break;default:g="set_temperature"}if(this._device[g]){var h=this._getWriteableGa(this._device[g]);if(h)if(h instanceof Error)b&&b(h);else switch(e){case "auto":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(0,c,h,function(a,c){a||(f.channel=g,f.state=c);b&&b(a,
a?null:f)}.bind(this));break;case "comfort":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(1,c,h,function(a,c){a||(f.channel=g,f.state=c);b&&b(a,a?null:f)}.bind(this));break;case "standby":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(2,c,h,function(a,c){a||(f.channel=g,f.state=c);b&&b(a,a?null:f)}.bind(this));break;case "economy":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(3,c,h,function(a,c){a||
(f.channel=g,f.state=c);b&&b(a,a?null:f)}.bind(this));break;case "protection":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);a.setValue(4,c,h,function(a,c){a||(f.channel=g,f.state=c);b&&b(a,a?null:f)}.bind(this));break;default:if(3<=e.length&&("inc"===e.substr(0,3).toLowerCase()||"dec"===e.substr(0,3).toLowerCase())){var k=e.substr(0,3),e=e.substr(3);""==e&&(e="2.0");e.match(/^[-+]?[0-9]*\.?[0-9]+$/)?(e=parseFloat(e),(d=this._getReadableGa(this._device[g]))?d instanceof Error?
b&&b(d):(a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a["inc"==k?"incValue":"decValue"](e,c,h,d,function(a,c){a||null==c||(f.channel=g,f.state=c);b&&b(a,a?null:f)})):b&&b(Error("invalid device has no readable address"))):b&&b(Error("invalid device command"))}else 2<e.length&&"to"===e.substr(0,2).toLowerCase()&&(e=e.substr(2)),e.match(/^[-+]?[0-9]*\.?[0-9]+$/)?(e=parseFloat(e),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a.setValue(e,c,h,function(a,c){a||
null==c||(f.channel=g,f.state=c);b&&b(a,a?null:f)})):b&&b(Error("invalid device command"))}else b&&b(Error("invalid device has no writeable address"))}else b&&b(Error("invalid device"))};
xnm.aio.knx.KNXGateway._Device.Heater.prototype.evalGroupCommand=function(a,c,b){var d={},f=a.command,e=a.channel;if(!e)switch(f){case "auto":case "comfort":case "standby":case "economy":case "protection":e="mode";break;default:e="set_temperature"}if(this._device[e]){var g=this._getWriteableGa(this._device[e]);if(g)if(g instanceof Error)b&&b(g);else switch(f){case "auto":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);a.evalValue(0,c,g,function(a,c){a||(d.channel=e,d.state=c);
b&&b(a,a?null:d)}.bind(this));break;case "comfort":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);a.evalValue(1,c,g,function(a,c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;case "standby":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);a.evalValue(2,c,g,function(a,c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;case "economy":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);a.evalValue(3,c,g,function(a,
c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;case "protection":a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);a.evalValue(4,c,g,function(a,c){a||(d.channel=e,d.state=c);b&&b(a,a?null:d)}.bind(this));break;default:3<=f.length&&("inc"===f.substr(0,3).toLowerCase()||"dec"===f.substr(0,3).toLowerCase())?b&&b(Error("invalid device group command")):(2<f.length&&"to"===f.substr(0,2).toLowerCase()&&(f=f.substr(2)),f.match(/^[-+]?[0-9]*\.?[0-9]+$/)?(f=parseFloat(f),
a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type),a.evalValue(f,c,g,function(a,c){a||null==c||(d.channel=e,d.state=c);b&&b(a,a?null:d)})):b&&b(Error("invalid device group command")))}else b&&b(Error("invalid device has no writeable address"))}else b&&b(Error("invalid device"))};xnm.aio.knx.KNXGateway._Device.Heater.prototype.getState=function(a,c,b){var d;a&&a.channel&&(d=a.channel);d||(d=this.getDefaultChannel());this._getState(d,c,b)};
xnm.aio.knx.KNXGateway._Device.Heater.prototype.getDefaultChannel=function(){return"set_temperature"};xnm.aio.knx.KNXGateway._Device.BIT_1=function(a){xnm.aio.knx.KNXGateway._Device.call(this,a)};xnm.aio.knx.KNXGateway._Device.BIT_1.prototype=new xnm.aio.knx.KNXGateway._Device;xnm.aio.knx.KNXGateway._Device.BIT_1.prototype.constructor=xnm.aio.knx.KNXGateway._Device.BIT_1;
xnm.aio.knx.KNXGateway._Device.BIT_1.prototype.doCommand=function(a,c,b){var d,f,e={};d=a.command;var g=a.channel;g||(g=this.getDefaultChannel());if(this._device[g])if(a=this._getWriteableGa(this._device[g]))if(a instanceof Error)b&&b(a);else switch(d){case "on":f=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);f.setValue(1,c,a,function(a,c){a||(e.channel=g,e.state=c);b&&b(a,a?null:e)}.bind(this));break;case "off":f=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);
f.setValue(0,c,a,function(a,c){a||(e.channel=g,e.state=c);b&&b(a,a?null:e)}.bind(this));break;case "toggle":d=this._getReadableGa(this._device[g]);if(!d){b&&b(Error("invalid device has no readable address"));break}if(d instanceof Error){b&&b(a);break}f=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type);f.invValue(c,a,d,function(a,c){a||(e.channel=g,e.state=c);b&&b(a,a?null:e)}.bind(this));break;default:b&&b(Error("invalid device command"))}else b&&b(Error("invalid device has no writeable address"));
else b&&b(Error("invalid device"))};
xnm.aio.knx.KNXGateway._Device.BIT_1.prototype.evalGroupCommand=function(a,c,b){var d,f={};d=a.command;var e=a.channel;e||(e=this.getDefaultChannel());if(this._device[e])if(a=this._getWriteableGa(this._device[e]))if(a instanceof Error)b&&b(a);else switch(d){case "on":d=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);d.evalValue(1,c,a,function(a,c){a||(f.channel=e,f.state=c);b&&b(a,a?null:f)}.bind(this));break;case "off":d=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type);d.evalValue(0,
c,a,function(a,c){a||(f.channel=e,f.state=c);b&&b(a,a?null:f)}.bind(this));break;default:b&&b(Error("invalid device group command"))}else b&&b(Error("invalid device has no writeable address"));else b&&b(Error("invalid device"))};xnm.aio.knx.KNXGateway._Device.BIT_1.prototype.getState=function(a,c,b){var d;a&&a.channel&&(d=a.channel);d||(d=this.getDefaultChannel());this._getState(d,c,b)};xnm.aio.knx.KNXGateway._Device.BIT_1.prototype.getDefaultChannel=function(){return"channel"};
xnm.aio.knx.KNXGateway._Device.Byte_1=function(a){xnm.aio.knx.KNXGateway._Device.call(this,a)};xnm.aio.knx.KNXGateway._Device.Byte_1.prototype=new xnm.aio.knx.KNXGateway._Device;xnm.aio.knx.KNXGateway._Device.Byte_1.prototype.constructor=xnm.aio.knx.KNXGateway._Device.Byte_1;
xnm.aio.knx.KNXGateway._Device.Byte_1.prototype.doCommand=function(a,c,b){var d,f={},e=a.command,g=a.channel;g||(g=this.getDefaultChannel());if(this._device[g]){var h=this._getWriteableGa(this._device[g]);if(h)if(h instanceof Error)b&&b(h);else if(3<=e.length&&("inc"===e.substr(0,3).toLowerCase()||"dec"===e.substr(0,3).toLowerCase())){var k=e.substr(0,3),e=e.substr(3);""==e&&(e="10");e.match(/^\d+$/)?(e=parseInt(e),(d=this._getReadableGa(this._device[g]))?d instanceof Error?b&&b(d):(a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),
a["inc"==k?"incValue":"decValue"](e,c,h,d,function(a,c){a||null==c||(f.channel=g,f.state=c);b&&b(a,a?null:f)})):b&&b(Error("invalid device has no readable address"))):b&&b(Error("invalid device command"))}else 6<e.length&&"moveto"===e.substr(0,6).toLowerCase()&&(e=e.substr(6)),e.match(/^\d+$/)?(e=parseInt(e),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[g].actuator.type),a.setValue(e,c,h,function(a,c){a||null==c||(f.channel=g,f.state=c);b&&b(a,a?null:f)})):b&&b(Error("invalid device command"));
else b&&b(Error("invalid device has no writeable address"))}else b&&b(Error("invalid device"))};
xnm.aio.knx.KNXGateway._Device.Byte_1.prototype.evalGroupCommand=function(a,c,b){var d={},f=a.command,e=a.channel;e||(e=this.getDefaultChannel());if(this._device[e]){var g=this._getWriteableGa(this._device[e]);g?g instanceof Error?b&&b(g):3<=f.length&&("inc"===f.substr(0,3).toLowerCase()||"dec"===f.substr(0,3).toLowerCase())?b&&b(Error("invalid device group command")):(6<f.length&&"moveto"===f.substr(0,6).toLowerCase()&&(f=f.substr(6)),f.match(/^\d+$/)?(f=parseInt(f),a=xnm.aio.knx.KNXGateway._DPT.resolve(this._device[e].actuator.type),
a.evalValue(f,c,g,function(a,c){a||null==c||(d.channel=e,d.state=c);b&&b(a,a?null:d)})):b&&b(Error("invalid device command"))):b&&b(Error("invalid device has no writeable address"))}else b&&b(Error("invalid device"))};xnm.aio.knx.KNXGateway._Device.Byte_1.prototype.getState=function(a,c,b){var d;a&&a.channel&&(d=a.channel);d||(d=this.getDefaultChannel());this._getState(d,c,b)};xnm.aio.knx.KNXGateway._Device.Byte_1.prototype.getDefaultChannel=function(){return"channel"};
xnm.aio.knx.KNXGateway._DataLink=function(a,c){this._logger=xnm.aio.knx.KNXGateway._DataLink._logger;var b=this;this._tunnel=new xnm.aio.knx.KNXGateway._Tunnel(a,null,c,null);this._tunnel.on("connect",function(){b._onTunnelConnect()});this._tunnel.on("end",function(){b._onTunnelEnd()});this._tunnel.on("close",function(a){b._onTunnelClose(a)});this._tunnel.on("message",function(a){b._onTunnelMessage(a)});this._tunnel.on("error",function(a){b._onTunnelError(a)});this._eventEmitter=new EventEmitter};
xnm.aio.knx.KNXGateway._DataLink._logger=Logger.getLogger("xnm.aio.knx.KNXGateway._DataLink");
xnm.aio.knx.KNXGateway._DataLink.prototype={on:function(a,c){this._eventEmitter.on(a,c)},removeAllListeners:function(){this._eventEmitter.removeAllListeners()},removeListener:function(a,c){this._eventEmitter.removeListener(a,c)},connect:function(){this._tunnel.connect()},close:function(){this._tunnel.close()},send:function(a,c,b){a=new xnm.aio.knx.KNXGateway.L_Data_Req(a,c);this._tunnel.send(a,function(a){b&&b(a)})},_onTunnelConnect:function(){this._eventEmitter.emit("connect")},_onTunnelClose:function(a){this._eventEmitter.emit("close",
a)},_onTunnelEnd:function(){this._eventEmitter.emit("end")},_onTunnelMessage:function(a){var c=a.getDstAddr();a=a.getAPDU();this._eventEmitter.emit("message",c,a)},_onTunnelError:function(a){this._eventEmitter.emit("error",a)}};
xnm.aio.knx.KNXGateway._Tunnel=function(a,c,b,d){this._logger=xnm.aio.knx.KNXGateway._Tunnel._logger;this._eventEmitter=new EventEmitter;this._ip=a;this._port=c;if(!this._port||0>=this._port)this._port=xnm.aio.knx.KNXGateway._Tunnel.DEFAULT_REMOTE_PORT;this._localIp=b;this._localPort=d;0>=this._localPort&&(this._localPort=null);this._socket=null;this._requestBuffer={};this._stateMachine={state:xnm.aio.knx.KNXGateway._Tunnel._STATE.IDLE,stateTimer:null,connectionStateTimer:null,connectionStateAckTimer:null,
connection:{id:0,seqNo:0,hpai:{ip:null,port:0}},close_with_error:null};this._MAX_CONNECT_STATE_NACK_COUNT=5;this._CONNECT_STATE_ACK_TIMEOUT=1E3;this._connectStateNackCount=0};xnm.aio.knx.KNXGateway._Tunnel._logger=Logger.getLogger("xnm.aio.knx.KNXGateway._Tunnel");xnm.aio.knx.KNXGateway._Tunnel.TUNNEL_ACK_TIMEOUT=200;xnm.aio.knx.KNXGateway._Tunnel.REQUEST_CON_TIMEOUT=5E3;xnm.aio.knx.KNXGateway._Tunnel.DEFAULT_REMOTE_PORT=3671;
xnm.aio.knx.KNXGateway._Tunnel._STATE={IDLE:0,BINDUDP:1,CONNECT:2,TUNNELLING:3,DISCONNECT:4,CLOSEUDP:5};
xnm.aio.knx.KNXGateway._Tunnel.prototype={on:function(a,c){this._eventEmitter.on(a,c)},removeAllListeners:function(){this._eventEmitter.removeAllListeners()},connect:function(){this._fsmConnect()},close:function(){this._fsmClose(!1)},send:function(a,c){var b=this;switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._Tunnel._STATE.TUNNELLING:this._logger.log("trace","send cEMI "+a.toBuffer().toString("hex"));var d=this._stateMachine.connection.seqNo,f=setTimeout(function(){if(b._requestBuffer[d]){var a=
b._requestBuffer[d];a.callback&&a.callback(Error("NACK due to timeout"));delete b._requestBuffer[d]}},xnm.aio.knx.KNXGateway._Tunnel.TUNNEL_ACK_TIMEOUT);this._requestBuffer[d]={timer:f,callback:c};this._stateMachine.connection.seqNo+=1;255<this._stateMachine.connection.seqNo&&(this._stateMachine.connection.seqNo=0);f=(new xnm.aio.knx.KNXGateway.TunnellingRequest(this._stateMachine.connection.id,d,a)).toBuffer();this._logger.log("trace","send TUNNELLING_REQUEST ("+d+") "+f.toString("hex"));this._socket.send(f,
0,f.length,this._port,this._ip);break;default:c&&c(Error("Tunnel is not connected"))}},_fsmConnect:function(){switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._Tunnel._STATE.IDLE:this._stateMachine.state=xnm.aio.knx.KNXGateway._Tunnel._STATE.BINDUDP,this._startListenerSocket()}},_fsmClose:function(a){this._stateMachine.close_with_error=a;switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._Tunnel._STATE.IDLE:this._fsmClosed();break;case xnm.aio.knx.KNXGateway._Tunnel._STATE.BINDUDP:this._stateMachine.state=
xnm.aio.knx.KNXGateway._Tunnel._STATE.CLOSEUDP;this._stopListenerSocket();break;case xnm.aio.knx.KNXGateway._Tunnel._STATE.CONNECT:this._clearStateMachineGuard();this._stateMachine.state=xnm.aio.knx.KNXGateway._Tunnel._STATE.CLOSEUDP;this._stopListenerSocket();break;case xnm.aio.knx.KNXGateway._Tunnel._STATE.TUNNELLING:a=(new xnm.aio.knx.KNXGateway.DisconnectRequest(this._stateMachine.connection.id,this._stateMachine.connection.hpai)).toBuffer(),this._logger.log("trace","send DISCONNECT_REQUEST "+
a.toString("hex")),this._socket.send(a,0,a.length,this._port,this._ip),this._stateMachine.state=xnm.aio.knx.KNXGateway._Tunnel._STATE.DISCONNECT,this._clearStateMachineGuard(),this._setStateMachineGuard(1E3,xnm.aio.knx.KNXGateway._Tunnel._STATE.CLOSEUDP)}},_fsmError:function(a){this._eventEmitter.emit("error",a);this._fsmClose(!0)},_fsmUdpListening:function(){switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._Tunnel._STATE.BINDUDP:this._stateMachine.state=xnm.aio.knx.KNXGateway._Tunnel._STATE.CONNECT;
this._clearStateMachineGuard();var a=this._socket.address(),a={ip:a.address,port:a.port},a=(new xnm.aio.knx.KNXGateway.ConnectionRequest(a,a)).toBuffer();this._socket.send(a,0,a.length,this._port,this._ip);this._setStateMachineGuard(1E3,xnm.aio.knx.KNXGateway._Tunnel._STATE.TUNNELLING)}},_fsmUdpMessage:function(a){var c=this,b=this._socket.address(),d=xnm.aio.knx.KNXGateway.IPFrame.parseFrame(a);switch(this._stateMachine.state){case xnm.aio.knx.KNXGateway._Tunnel._STATE.CONNECT:518===d.getType()&&
d.isConnectionStatusOK()&&(this._clearStateMachineGuard(),a=d.getConnectionID(),this._logger.log("trace","receive CONNECTION_RESPONSE with connection id "+a),this._stateMachine.connection={},this._stateMachine.connection.id=a,b={ip:b.address,port:b.port},this._stateMachine.connection.hpai=b,this._stateMachine.connection.seqNo=0,this._stateMachine.state=xnm.aio.knx.KNXGateway._Tunnel._STATE.TUNNELLING,this._sendConnectionStateRequest(),this._onConnected());break;case xnm.aio.knx.KNXGateway._Tunnel._STATE.TUNNELLING:switch(d.getType()){case 1056:a=
d.getConnectionID();a===this._stateMachine.connection.id&&(b=d.getcEMI(),d=d.getSeqNo(),d=new xnm.aio.knx.KNXGateway.TunnellingACK(a,d),a=d.toBuffer(),this._logger.log("trace","send TUNNELLING_ACK "+a.toString("hex")),this._socket.send(a,0,a.length,this._port,this._ip),b&&b instanceof xnm.aio.knx.KNXGateway.L_Data_Con?(this._logger.log("debug","receive TUNNELLING_REQUEST l_data.con"),this._onMessage(b)):b&&b instanceof xnm.aio.knx.KNXGateway.L_Data_Ind&&(this._logger.log("debug","receive TUNNELLING_REQUEST l_data.ind"),
this._onMessage(b)));break;case 1057:a=d.getConnectionID();a===this._stateMachine.connection.id&&this._onTunnelAck(d);break;case 521:a=d.getConnectionID();b=d.getCtrlEndpointHPAI();a===this._stateMachine.connection.id&&(this._logger.log("debug","receive DISCONNECT_REQUEST"),d=new xnm.aio.knx.KNXGateway.DisconnectResponse(a),a=d.toBuffer(),this._logger.log("trace","send DISCONNECT_RESPONSE "+a.toString("hex")),this._socket.send(a,0,a.length,this._port,this._ip,function(){c._fsmEnd()}));break;case 520:a=
d.getConnectionID(),this._logger.log("debug","receive CONNECTIONSTATE_RESPONSE with connection id "+a),this._connectStateNackCount=0,this._stateMachine.connectionStateAckTimer&&(clearTimeout(this._stateMachine.connectionStateAckTimer),this._stateMachine.connectionStateAckTimer=null,this._stateMachine.connectionStateTimer||(this._stateMachine.connectionStateTimer=setTimeout(function(){c._stateMachine.connectionStateTimer=null;c._sendConnectionStateRequest()},1E4)))}break;case xnm.aio.knx.KNXGateway._Tunnel._STATE.DISCONNECT:522===
d.getType()&&(a=d.getConnectionID(),a===this._stateMachine.connection.id&&(a=d.isDisconnectOK(),this._logger.log("debug","receive DISCONNECT_RESPONSE with status "+(a?"OK":"NOK")),this._clearStateMachineGuard(),this._stateMachine.state=xnm.aio.knx.KNXGateway._Tunnel._STATE.CLOSEUDP,c._stopListenerSocket()))}},_fsmEnd:function(){this._stateMachine.state=xnm.aio.knx.KNXGateway._Tunnel._STATE.CLOSEUDP;this._eventEmitter.emit("end");this._stateMachine.close_with_error=!1;this._stopListenerSocket()},_fsmClosed:function(){this._stateMachine.state=
xnm.aio.knx.KNXGateway._Tunnel._STATE.IDLE;var a=this._stateMachine.close_with_error;this._socket&&this._socket.removeAllListeners();this._socket=null;this._clearRequestBuffer();this._resetStateMachine();this._eventEmitter.emit("close",a)},_onConnected:function(){this._eventEmitter.emit("connect")},_onMessage:function(a){this._eventEmitter.emit("message",a)},_onTunnelAck:function(a){var c=a.getSeqNo();a=a.isOK();this._logger.log("debug","receive TUNNELLING_ACK for "+c+" with status "+(a?"OK":"NOK"));
if(this._requestBuffer[c]){var b=this._requestBuffer[c];b.timer&&clearTimeout(b.timer);b.callback&&b.callback(a?null:Error("NACK"));delete this._requestBuffer[c]}},_clearRequestBuffer:function(){for(var a in this._requestBuffer)if(this._requestBuffer.hasOwnProperty(a)){var c=this._requestBuffer[a];c&&(c.timer&&clearTimeout(c.timer),c.callback&&c.callback(Error("NACK due to tunnel closed")))}this._requestBuffer={}},_setStateMachineGuard:function(a,c){var b=this;this._stateMachine.stateTimer=setTimeout(function(){var a=
b._stateMachine.state;a===xnm.aio.knx.KNXGateway._Tunnel._STATE.DISCONNECT&&c===xnm.aio.knx.KNXGateway._Tunnel._STATE.CLOSEUDP?(b._stateMachine.state=xnm.aio.knx.KNXGateway._Tunnel._STATE.CLOSEUDP,b._stopListenerSocket()):a!==c&&b._fsmError(Error("knx tunnel receive data timeout in "+a))},a)},_clearStateMachineGuard:function(){this._stateMachine.stateTimer&&clearTimeout(this._stateMachine.stateTimer)},_sendConnectionStateRequest:function(){var a=this,c=(new xnm.aio.knx.KNXGateway.ConnectionStateRequest(this._stateMachine.connection.id,
this._stateMachine.connection.hpai)).toBuffer();this._logger.log("trace","send CONNECTIONSTATE_REQUEST "+c.toString("hex")+" with connection id "+this._stateMachine.connection.id);this._socket.send(c,0,c.length,this._port,this._ip);this._stateMachine.connectionStateAckTimer=setTimeout(function(){a._connectStateNackCount<a._MAX_CONNECT_STATE_NACK_COUNT&&a._stateMachine.state===xnm.aio.knx.KNXGateway._Tunnel._STATE.TUNNELLING?(a._connectStateNackCount++,a._sendConnectionStateRequest()):a._fsmError(Error("tunnel break"))},
this._CONNECT_STATE_ACK_TIMEOUT)},_resetStateMachine:function(){this._stateMachine.stateTimer&&clearTimeout(this._stateMachine.stateTimer);this._stateMachine.connectionStateTimer&&clearTimeout(this._stateMachine.connectionStateTimer);this._stateMachine.connectionStateAckTimer&&clearTimeout(this._stateMachine.connectionStateAckTimer);this._stateMachine={state:xnm.aio.knx.KNXGateway._Tunnel._STATE.IDLE,stateTimer:null,connectionStateTimer:null,connectionStateAckTimer:null,socket:null,connection:{id:0,
seqNo:0,hpai:{ip:null,port:0}},close_with_error:null}},_startListenerSocket:function(){var a=this;this._socket=dgram.createSocket("udp4");this._socket.on("listening",function(){a._socket.addMembership("224.0.23.12");var c=a._socket.address();a._logger.log("debug","knx listening "+c.address+":"+c.port);a._fsmUdpListening()});this._socket.on("close",function(){a._logger.log("debug","control socket closed");a._fsmClosed()});this._socket.on("error",function(c){a._logger.log("debug","control socket error: "+
c.stack);a._fsmError(c)});this._socket.on("message",function(c,b){var d=a._socket.address();a._logger.log("trace","receive data "+c.toString("hex")+" from "+b.address+":"+b.port+" @local "+d.address+":"+d.port);a._fsmUdpMessage(c)});this._socket.bind(null,this._localIp)},_stopListenerSocket:function(){this._socket.close()}};
xnm.aio.knx.KNXGateway.IPFrame=function(a,c){a&&c&&(this._buffer=new Buffer(6+c.length),this._buffer.writeUInt16BE(1552,0),this._buffer.writeUInt16BE(a,2),this._buffer.writeUInt16BE(6+c.length,4),c.copy(this._buffer,6))};xnm.aio.knx.KNXGateway.IPFrame._logger=Logger.getLogger("xnm.aio.knx.ipframe");
xnm.aio.knx.KNXGateway.IPFrame.parseFrame=function(a){var c=null;if(6>a.length)return xnm.aio.knx.KNXGateway.IPFrame._logger.log("debug","data is too short"),null;var b=a.readUInt16BE(0);if(1552!==b)return xnm.aio.knx.KNXGateway.IPFrame._logger.log("debug","data header&version is invalid:"+b),null;b=a.readUInt16BE(4);if(b>a.length)return xnm.aio.knx.KNXGateway.IPFrame._logger.log("debug","data length in header is larger than actual size:"+b),null;var d=a.readUInt16BE(2);switch(d){case 514:14<=b&&
(c=new xnm.aio.knx.KNXGateway.SearchResponse);break;case 518:8<=b&&(c=new xnm.aio.knx.KNXGateway.ConnectionResponse);break;case 520:8<=b&&(c=new xnm.aio.knx.KNXGateway.ConnectionStateResponse);break;case 1057:10<=b&&(c=new xnm.aio.knx.KNXGateway.TunnellingACK);break;case 1056:6<=b&&(c=new xnm.aio.knx.KNXGateway.TunnellingRequest);break;case 521:16<=b&&(c=new xnm.aio.knx.KNXGateway.DisconnectRequest);break;case 522:8<=b&&(c=new xnm.aio.knx.KNXGateway.DisconnectResponse);break;default:xnm.aio.knx.KNXGateway.IPFrame._logger.log("debug",
"data type is unknow:"+d)}c&&(c._buffer=a);return c};xnm.aio.knx.KNXGateway.IPFrame.prototype.getType=function(){return this._buffer.readUInt16BE(2)};xnm.aio.knx.KNXGateway.IPFrame.prototype.getSize=function(){return this._buffer.readUInt16BE(4)};xnm.aio.knx.KNXGateway.IPFrame.prototype.toBuffer=function(){return this._buffer};
xnm.aio.knx.KNXGateway.SearchRequest=function(a){var c=new Buffer(8);c.writeUInt16BE(2049,0);c.writeInt32BE(xnm.aio.knx.KNXGateway._ipv4ToLong(a.ip),2);c.writeUInt16BE(a.port,6);xnm.aio.knx.KNXGateway.IPFrame.call(this,513,c)};xnm.aio.knx.KNXGateway.SearchRequest.prototype=new xnm.aio.knx.KNXGateway.IPFrame;xnm.aio.knx.KNXGateway.SearchRequest.prototype.constructor=xnm.aio.knx.KNXGateway.SearchRequest;xnm.aio.knx.KNXGateway.SearchResponse=function(){xnm.aio.knx.KNXGateway.IPFrame.call(this)};
xnm.aio.knx.KNXGateway.SearchResponse.prototype=new xnm.aio.knx.KNXGateway.IPFrame;xnm.aio.knx.KNXGateway.SearchResponse.prototype.constructor=xnm.aio.knx.KNXGateway.SearchResponse;xnm.aio.knx.KNXGateway.SearchResponse.prototype.getCtrlEndpointHPAI=function(){var a=this._buffer.readUInt32BE(8),a=xnm.aio.knx.KNXGateway._longToIpv4(a),c=this._buffer.readUInt16BE(12),b={};b.ip=a;b.port=c;return b};
xnm.aio.knx.KNXGateway.SearchResponse.prototype.getSerialNumber=function(){var a=(this._buffer.readUInt8(22)<<16)+(this._buffer.readUInt8(23)<<8)+this._buffer.readUInt8(24),c=(this._buffer.readUInt8(25)<<16)+(this._buffer.readUInt8(26)<<8)+this._buffer.readUInt8(27);return a+""+c};xnm.aio.knx.KNXGateway.SearchResponse.prototype.getRoutingMulticastAddress=function(){return this._buffer.readUInt8(28)+"."+this._buffer.readUInt8(29)+"."+this._buffer.readUInt8(30)+"."+this._buffer.readUInt8(31)};
xnm.aio.knx.KNXGateway.SearchResponse.prototype.getMAC=function(){return this._buffer.toString("hex",32,38)};xnm.aio.knx.KNXGateway.SearchResponse.prototype.getName=function(){return this._buffer.toString("utf8",38,68)};
xnm.aio.knx.KNXGateway.SearchResponse.prototype.toJSON=function(){return{hapi:this.getCtrlEndpointHPAI(),structure_length:this._buffer.readUInt8(14),desciprtion_type_code:this._buffer.readUInt8(15),knx_medium:this._buffer.readUInt8(16),device_status:this._buffer.readUInt8(17),physical_address:this._buffer.readUInt16BE(18),project_installation_id:this._buffer.readUInt16BE(20),serial_number:this.getSerialNumber(),routing_multicast_address:this.getRoutingMulticastAddress(),mac:this.getMAC(),name:this.getName()}};
xnm.aio.knx.KNXGateway.ConnectionRequest=function(a,c){var b=new Buffer(20);b.writeUInt16BE(2049,0);b.writeInt32BE(xnm.aio.knx.KNXGateway._ipv4ToLong(a.ip),2);b.writeUInt16BE(a.port,6);b.writeUInt16BE(2049,8);b.writeInt32BE(xnm.aio.knx.KNXGateway._ipv4ToLong(c.ip),10);b.writeUInt16BE(c.port,14);b.writeUInt8(4,16);b.writeUInt8(4,17);b.writeUInt8(2,18);b.writeUInt8(0,19);xnm.aio.knx.KNXGateway.IPFrame.call(this,517,b)};xnm.aio.knx.KNXGateway.ConnectionRequest.prototype=new xnm.aio.knx.KNXGateway.IPFrame;
xnm.aio.knx.KNXGateway.ConnectionRequest.prototype.constructor=xnm.aio.knx.KNXGateway.ConnectionRequest;xnm.aio.knx.KNXGateway.ConnectionResponse=function(){xnm.aio.knx.KNXGateway.IPFrame.call(this)};xnm.aio.knx.KNXGateway.ConnectionResponse.prototype=new xnm.aio.knx.KNXGateway.IPFrame;xnm.aio.knx.KNXGateway.ConnectionResponse.prototype.constructor=xnm.aio.knx.KNXGateway.ConnectionResponse;xnm.aio.knx.KNXGateway.ConnectionResponse.prototype.getConnectionID=function(){return this._buffer.readUInt8(6)};
xnm.aio.knx.KNXGateway.ConnectionResponse.prototype.isConnectionStatusOK=function(){return 0===this._buffer.readUInt8(7)};xnm.aio.knx.KNXGateway.ConnectionResponse.prototype.getCtrlEndpointHPAI=function(){var a=this._buffer.readUInt32BE(10),a=xnm.aio.knx.KNXGateway._longToIpv4(a),c=this._buffer.readUInt16BE(14),b={};b.ip=a;b.port=c;return b};xnm.aio.knx.KNXGateway.ConnectionResponse.prototype.getCRD=function(){return this._buffer.readUInt32BE(16)};
xnm.aio.knx.KNXGateway.ConnectionStateRequest=function(a,c){var b=new Buffer(10);b.writeUInt8(a,0);b.writeUInt8(0,1);b.writeUInt16BE(2049,2);b.writeInt32BE(xnm.aio.knx.KNXGateway._ipv4ToLong(c.ip),4);b.writeUInt16BE(c.port,8);xnm.aio.knx.KNXGateway.IPFrame.call(this,519,b)};xnm.aio.knx.KNXGateway.ConnectionStateRequest.prototype=new xnm.aio.knx.KNXGateway.IPFrame;xnm.aio.knx.KNXGateway.ConnectionStateRequest.prototype.constructor=xnm.aio.knx.KNXGateway.ConnectionStateRequest;
xnm.aio.knx.KNXGateway.ConnectionStateResponse=function(){xnm.aio.knx.KNXGateway.IPFrame.call(this)};xnm.aio.knx.KNXGateway.ConnectionStateResponse.prototype=new xnm.aio.knx.KNXGateway.IPFrame;xnm.aio.knx.KNXGateway.ConnectionStateResponse.prototype.constructor=xnm.aio.knx.KNXGateway.ConnectionStateResponse;xnm.aio.knx.KNXGateway.ConnectionStateResponse.prototype.getConnectionID=function(){return this._buffer.readUInt8(6)};
xnm.aio.knx.KNXGateway.ConnectionStateResponse.prototype.isConnectionStatusOK=function(){return 0===this._buffer.readUInt8(7)};xnm.aio.knx.KNXGateway.TunnellingRequest=function(a,c,b){if(null!==a&&void 0!==a&&null!==c&&void 0!==c&&b){var d=new Buffer(4+b.getLength());d.writeUInt8(4,0);d.writeUInt8(a,1);d.writeUInt8(c,2);d.writeUInt8(0,3);b.toBuffer().copy(d,4);xnm.aio.knx.KNXGateway.IPFrame.call(this,1056,d)}else xnm.aio.knx.KNXGateway.IPFrame.call(this)};
xnm.aio.knx.KNXGateway.TunnellingRequest.prototype=new xnm.aio.knx.KNXGateway.IPFrame;xnm.aio.knx.KNXGateway.TunnellingRequest.prototype.constructor=xnm.aio.knx.KNXGateway.TunnellingRequest;xnm.aio.knx.KNXGateway.TunnellingRequest.prototype.getConnectionID=function(){return this._buffer.readUInt8(7)};xnm.aio.knx.KNXGateway.TunnellingRequest.prototype.getSeqNo=function(){return this._buffer.readUInt8(8)};
xnm.aio.knx.KNXGateway.TunnellingRequest.prototype.getcEMI=function(){var a=this._buffer.readUInt16BE(4),a=new Buffer(a-6-4);this._buffer.copy(a,0,10);return xnm.aio.knx.KNXGateway.cEMI.parseFrame(a)};xnm.aio.knx.KNXGateway.TunnellingACK=function(a,c){if(a){var b=new Buffer(4);b.writeUInt8(4,0);b.writeUInt8(a,1);b.writeUInt8(c,2);b.writeUInt8(0,3);xnm.aio.knx.KNXGateway.IPFrame.call(this,1057,b)}else xnm.aio.knx.KNXGateway.IPFrame.call(this)};xnm.aio.knx.KNXGateway.TunnellingACK.prototype=new xnm.aio.knx.KNXGateway.IPFrame;
xnm.aio.knx.KNXGateway.TunnellingACK.prototype.constructor=xnm.aio.knx.KNXGateway.TunnellingACK;xnm.aio.knx.KNXGateway.TunnellingACK.prototype.getConnectionID=function(){return this._buffer.readUInt8(7)};xnm.aio.knx.KNXGateway.TunnellingACK.prototype.getSeqNo=function(){return this._buffer.readUInt8(8)};xnm.aio.knx.KNXGateway.TunnellingACK.prototype.isOK=function(){return 0===this._buffer.readUInt8(9)};
xnm.aio.knx.KNXGateway.DisconnectRequest=function(a,c){if(a&&null!==c){var b=new Buffer(10);b.writeUInt8(a,0);b.writeUInt8(0,1);b.writeUInt8(8,2);b.writeUInt8(1,3);b.writeInt32BE(xnm.aio.knx.KNXGateway._ipv4ToLong(c.ip),4);b.writeUInt16BE(c.port,8);xnm.aio.knx.KNXGateway.IPFrame.call(this,521,b)}else xnm.aio.knx.KNXGateway.IPFrame.call(this)};xnm.aio.knx.KNXGateway.DisconnectRequest.prototype=new xnm.aio.knx.KNXGateway.IPFrame;xnm.aio.knx.KNXGateway.DisconnectRequest.prototype.constructor=xnm.aio.knx.KNXGateway.DisconnectRequest;
xnm.aio.knx.KNXGateway.DisconnectRequest.prototype.getConnectionID=function(){return this._buffer.readUInt8(6)};xnm.aio.knx.KNXGateway.DisconnectRequest.prototype.getCtrlEndpointHPAI=function(){var a=this._buffer.readUInt32BE(10),a=xnm.aio.knx.KNXGateway._longToIpv4(a),c=this._buffer.readUInt16BE(14),b={};b.ip=a;b.port=c;return b};xnm.aio.knx.KNXGateway.DisconnectResponse=function(a){if(a){var c=new Buffer(2);c.writeUInt8(a,0);c.writeUInt8(0,1);xnm.aio.knx.KNXGateway.IPFrame.call(this,1057,c)}else xnm.aio.knx.KNXGateway.IPFrame.call(this)};
xnm.aio.knx.KNXGateway.DisconnectResponse.prototype=new xnm.aio.knx.KNXGateway.IPFrame;xnm.aio.knx.KNXGateway.DisconnectResponse.prototype.constructor=xnm.aio.knx.KNXGateway.DisconnectResponse;xnm.aio.knx.KNXGateway.DisconnectResponse.prototype.getConnectionID=function(){return this._buffer.readUInt8(6)};xnm.aio.knx.KNXGateway.DisconnectResponse.prototype.isDisconnectOK=function(){return 0===this._buffer.readUInt8(7)};xnm.aio.knx.KNXGateway.cEMI=function(a){this._buffer=a};
xnm.aio.knx.KNXGateway.cEMI.parseFrame=function(a){var c=null;switch(a.readUInt8(0)){case xnm.aio.knx.KNXGateway.L_Data_Con.MSG_CODE:c=new xnm.aio.knx.KNXGateway.L_Data_Con;break;case xnm.aio.knx.KNXGateway.L_Data_Ind.MSG_CODE:c=new xnm.aio.knx.KNXGateway.L_Data_Ind}c&&(c._buffer=a);return c};
xnm.aio.knx.KNXGateway.cEMI.prototype={getLength:function(){return this._buffer.length},getDstAddr:function(){return this._buffer.readUInt16BE(6)},getDataLength:function(){return this._buffer.readUInt8(8)},getAPDU:function(){var a=this.getDataLength()+1,a=new Buffer(a);this._buffer.copy(a,0,9,9+a.length);return xnm.aio.knx.KNXGateway.APDU.parse(a)},toBuffer:function(){return this._buffer}};
xnm.aio.knx.KNXGateway.L_Data_Req=function(a,c){var b=new Buffer(9+c.getLength());b.writeUInt8(17,0);b.writeUInt8(0,1);b.writeUInt8(188,2);b.writeUInt8(224,3);b.writeUInt8(0,4);b.writeUInt8(0,5);b.writeInt16BE(a,6);b.writeUInt8(c.getLength()-1,8);c.toBuffer().copy(b,9);xnm.aio.knx.KNXGateway.cEMI.call(this,b)};xnm.aio.knx.KNXGateway.L_Data_Req.MSG_CODE=17;xnm.aio.knx.KNXGateway.L_Data_Req.prototype=new xnm.aio.knx.KNXGateway.cEMI;xnm.aio.knx.KNXGateway.L_Data_Req.prototype.constructor=xnm.aio.knx.KNXGateway.L_Data_Req;
xnm.aio.knx.KNXGateway.L_Data_Con=function(){xnm.aio.knx.KNXGateway.cEMI.call(this)};xnm.aio.knx.KNXGateway.L_Data_Con.MSG_CODE=46;xnm.aio.knx.KNXGateway.L_Data_Con.prototype=new xnm.aio.knx.KNXGateway.cEMI;xnm.aio.knx.KNXGateway.L_Data_Con.prototype.constructor=xnm.aio.knx.KNXGateway.L_Data_Con;xnm.aio.knx.KNXGateway.L_Data_Ind=function(){xnm.aio.knx.KNXGateway.cEMI.call(this)};xnm.aio.knx.KNXGateway.L_Data_Ind.MSG_CODE=41;xnm.aio.knx.KNXGateway.L_Data_Ind.prototype=new xnm.aio.knx.KNXGateway.cEMI;
xnm.aio.knx.KNXGateway.L_Data_Ind.prototype.constructor=xnm.aio.knx.KNXGateway.L_Data_Ind;xnm.aio.knx.KNXGateway.APDU=function(a,c,b){c||(c=0);a||(a=0);var d=1;b&&1<b.length&&(d=b.length);this._buffer=new Buffer(1+d);this._buffer.writeUInt8(a|c>>2,0);a=b&&0<b.length?b.readUInt8(0):0;this._buffer.writeUInt8(c<<6|a,1);b&&1<b.length&&b.copy(this._buffer,2,1)};xnm.aio.knx.KNXGateway.APDU.parse=function(a){var c=new xnm.aio.knx.KNXGateway.APDU;c._buffer=a;return c};
xnm.aio.knx.KNXGateway.APDU.prototype={getLength:function(){return this._buffer.length},getAPCI:function(){var a=this._buffer.readUInt8(0),c=this._buffer.readUInt8(1);return(a&3)<<2|(c&192)>>6&3},getData:function(){var a=this._buffer.length-1,c=this._buffer.readUInt8(1),b=new Buffer(a);b.writeUInt8(c&63,0);1<a&&this._buffer.copy(b,1,2);return b},toBuffer:function(){return this._buffer}};
xnm.aio.knx.KNXGateway.Discovery={_eventEmitter:new EventEmitter,_logger:Logger.getLogger("xnm.aio.knx.KNXGateway.Discovery"),_listenerSockets:[],_closedSockets:[],on:function(a,c){this._eventEmitter.on(a,c)},removeAllListeners:function(){this._eventEmitter.removeAllListeners()},startSearchKNX:function(){if(os&&os.networkInterfaces){var a=os.networkInterfaces(),c;for(c in a)for(var b=a[c],d=0;d<b.length;d++){var f=b[d];!1===f.internal&&"IPv4"===f.family&&this._createSocket(f.address)}}else this._createSocket(null);
this._closedSockets=[]},stopSearchKNX:function(){for(var a=0;a<this._listenerSockets.length;a++)this._listenerSockets[a].close()},_createSocket:function(a){var c=this,b=dgram.createSocket("udp4");b.on("listening",function(){b.addMembership("224.0.23.12");b.setBroadcast(!0);var a=b.address();c._logger.log("debug","knx discovery socket listening "+a.address+":"+a.port);c._listenerSockets.push(b);var f=(new xnm.aio.knx.KNXGateway.SearchRequest({ip:a.address,port:a.port})).toBuffer();c._logger.log("debug",
"send knx search request: "+f.toString("hex")+" from "+a.address+":"+a.port);b.send(f,0,f.length,3671,"224.0.23.12")});b.on("message",function(a,f){var e=b.address();c._logger.log("trace","receive data "+a.toString("hex")+" from "+f.address+":"+f.port+" @local "+e.address+":"+e.port);var g=xnm.aio.knx.KNXGateway.IPFrame.parseFrame(a);if(g instanceof xnm.aio.knx.KNXGateway.SearchResponse){var h=g.getCtrlEndpointHPAI();c._logger.log("debug","find knx "+h.ip+":"+h.port);c._eventEmitter.emit("found",
g,e)}});b.on("error",function(a){c._logger.log("debug","discovery socket error: "+a.stack);c._eventEmitter.emit("error",a)});b.on("close",function(){c._logger.log("debug","discovery socket closed");c._closedSockets.push(b);c._listenerSockets.length===c._closedSockets.length&&(c._listenerSockets=[],c._closedSockets=[],c._eventEmitter.emit("close"))});b.bind(null,a)}};
xnm.aio.knx.KNXGateway.EventResolver={resolve:function(a,c,b,d){return(a=xnm.aio.knx.KNXGateway._Device.resolve(a))?a._resolveEvent(d.getData(),c):null}};xnm.aio.knx.Handler=function(){this._listenerSockets=[]};xnm.aio.knx.Handler.prototype={KNXGateway:xnm.aio.knx.KNXGateway,Finder:xnm.aio.knx.KNXGateway.Discovery,EventResolver:xnm.aio.knx.KNXGateway.EventResolver};"undefined"!=typeof module&&null!=module&&(module.exports=new xnm.aio.knx.Handler);
